unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Unit2, Buttons;

type
  TForm3 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    SpinEdit1: TSpinEdit;
    Label5: TLabel;
    SpinEdit2: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label8: TLabel;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox1: TCheckBox;
    Label10: TLabel;
    Edit3: TEdit;
    Label11: TLabel;
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

  new_os : osoba_p;

implementation

{$R *.DFM}

procedure TForm3.ComboBox1Change(Sender: TObject);
var os : osoba_p;
begin
 os := dej_id(combobox1.text);
 label8.caption := '---';
 if not assigned(os) then
  exit;
 label8.caption := os^.jmeno + ' ' + os^.prijmeni;
end;

procedure TForm3.ComboBox2Change(Sender: TObject);
var os : osoba_p;
begin
 os := dej_id(combobox2.text);
 label9.caption := '---';
 if not assigned(os) then
  exit;
 label9.caption := os^.jmeno + ' ' + os^.prijmeni;
end;

procedure TForm3.FormShow(Sender: TObject);
var i  : integer;
    os : osoba_p;
begin
 if assigned(new_os) then
 begin
  edit1.text := new_os.jmeno;
  edit2.text := new_os.prijmeni;
  edit3.text := new_os.id;
  combobox1.text := new_os.matka;
  combobox2.text := new_os.otec;
  spinedit1.value := new_os.narozeni;
  spinedit2.value := new_os.umrti;
  checkbox1.checked := new_os.muz;  
 end;

 if not assigned(rodokmen) then
  exit;
 if rodokmen.count > 0 then
 for i := 0 to rodokmen.count-1 do
  if assigned(rodokmen.items[i]) then
  begin
   os := rodokmen.items[i];
   if os.id = '' then
    continue;
   if os.muz then
    combobox2.items.add(os.id) else
    combobox1.items.add(os.id);
  end;
 if not assigned(new_os) then
  edit3.text := 'I'+inttostr(random(100000));
end;

procedure TForm3.BitBtn2Click(Sender: TObject);
begin
 close;
end;

procedure TForm3.BitBtn1Click(Sender: TObject);
begin
 if assigned(dej_id(edit3.text)) then
  begin
   messagebox(handle,'Nemuzete pouzit toto ID, uz ho pouziva nekdo jiny!','Chyba!',mb_iconhand or mb_ok);
   exit;
  end;
 if not assigned(new_os) then
  new(new_os);
 new_os.jmeno := edit1.text;
 new_os.prijmeni := edit2.text;
 new_os.muz := checkbox1.checked;
 new_os.narozeni := spinedit1.value;
 new_os.umrti := spinedit2.value;
 new_os.matka := combobox1.text;
 new_os.otec := combobox2.text;
 new_os.id := edit3.text;
 //
 modalresult := mrOk;
end;

end.
