unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, Unit2, Math;

type
  TForm4 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    BitBtn3: TBitBtn;
    ListView1: TListView;
    Label3: TLabel;
    BitBtn4: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
    fn1, fn2 : string;
    rod1, rod2 : tlist;
    procedure VlozStejnou(os1, os2 : osoba_p);
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.DFM}

procedure TForm4.BitBtn1Click(Sender: TObject);
begin
 if opendialog1.execute then
 begin
  fn1 := opendialog1.filename;
  label1.caption := opendialog1.filename;
 end;
 bitbtn3.enabled := (fileexists(fn1))and(fileexists(fn2));
end;

procedure TForm4.BitBtn2Click(Sender: TObject);
begin
 if opendialog1.execute then
 begin
  fn2 := opendialog1.filename;
  label2.caption := opendialog1.filename;
 end;
 bitbtn3.enabled := (fileexists(fn1))and(fileexists(fn2));
end;

procedure TForm4.FormShow(Sender: TObject);
begin
 fn1 := '';
 fn2 := '';
 bitbtn3.enabled := false;
 listview1.items.clear;
end;

procedure TForm4.VlozStejnou(os1, os2 : osoba_p);
var li : tlistitem;
begin
 li := listview1.items.add;
 li.caption := os1^.id;
 li.subitems.add(os1^.jmeno);
 li.subitems.add(os1^.prijmeni);
 li.subitems.add(os2^.id);
 li.subitems.add(os2^.jmeno);
 li.subitems.add(os2^.prijmeni);
end;

procedure TForm4.BitBtn3Click(Sender: TObject);
var i,j   : integer;
    s     : string;
label znova;
begin
 ClearList(rod1);
 ClearList(rod2);
 rod1 := tlist.create;
 rod2 := tlist.create;
 //nacti 1
 if not parsexml(fn1) then
  begin messagebox(handle,'Chyba pri slucovani - pri nacitani druheho XML souboru!','chyba',mb_iconhand or mb_ok);exit;end;
 //prekopiruj 1
 for i := 0 to rodokmen_l.count-1 do
 begin
  rod1.add(rodokmen_l.items[i]);
 end;
 rodokmen_l.free;
 rodokmen_l := nil;
 //nacti 2
 if not parsexml(fn2) then
  begin messagebox(handle,'Chyba pri slucovani - pri nacitani druheho XML souboru!','chyba',mb_iconhand or mb_ok);exit;end;
 //prekopiruj 2
 for i := 0 to rodokmen_l.count-1 do
 begin
  rod2.add(rodokmen_l.items[i]);
 end;
 rodokmen_l.free;
 rodokmen_l := nil;
 //
 //->sluc to<-
 //
 if (rod1.count <=0)and(rod2.count<=0) then
  begin messagebox(handle,'Chyba pri slucovani - oba XML jsou prazdne!','chyba',mb_iconhand or mb_ok);exit;end;
 //
 ClearList(rodokmen);
 rodokmen := tlist.create;
 rodokmen.clear;
 //najdi identicke polozky
znova:
 for i := 0 to rod1.count-1 do
  if assigned(rod1.items[i]) then
   for j := 0 to rod2.count-1 do
   if assigned(rod2.items[j]) then
    if osoba_p(rod2.items[j])^.id = osoba_p(rod1.items[i])^.id then
    begin
     VlozStejnou(osoba_p(rod2.items[j]),osoba_p(rod1.items[i]));
     if RadioButton1.Checked then //odstranit z druheho
     begin
      try rod2.remove(rod2.items[j]); except end;
      try dispose(rod2.items[j]); except end;
      rod2.pack;
      goto znova;
     end;
    end;
 //vloz do rodokmenu
 for i := 0 to rod1.count-1 do
  if assigned(rod1.items[i]) then
  begin
   rodokmen.add(rod1.items[i]);
  end;
 rod1.free;
 rod1 := nil;
 //
 s := '_ID_2_SOUBOR_'+inttostr(random(24));
 for i := 0 to rod2.count-1 do
  if assigned(rod2.items[i]) then
  begin
   if radiobutton2.checked then
   begin //vytvor nove id
    if osoba_p(rod2.items[i])^.id <> '' then
     osoba_p(rod2.items[i])^.id := osoba_p(rod2.items[i])^.id + s;
    if osoba_p(rod2.items[i])^.otec <> '' then
     osoba_p(rod2.items[i])^.otec := osoba_p(rod2.items[i])^.otec + s;
    if osoba_p(rod2.items[i])^.matka <> '' then
     osoba_p(rod2.items[i])^.matka := osoba_p(rod2.items[i])^.matka + s;
   end;
   rodokmen.add(rod2.items[i]);
  end;
 rod2.free;
 rod2 := nil;
end;

end.
